#version 330
out vec4 fragColor;

in float val;

uniform bool rainbow;
uniform float contMin = 0.0;
uniform float contMax = 10.0;

vec4 farbverlauf(float wrt){
    float _min = contMin;
    float _max = contMax;
    if (_min+0.001>=_max)_max+=0.002;
    vec4 ff;
    int lauf=0;
    const vec4 farbe[]= vec4[6](
      vec4(1.0,0.0,0.0,1.0),
      vec4(1.0,1.0,0.0,1.0),
      vec4(0.0,1.0,0.0,1.0),
      vec4(0.0,1.0,1.0,1.0),
      vec4(0.0,0.0,1.0,1.0),
      vec4(1.0,0.0,1.0,1.0));
    float nwrt = (wrt - _min) / (_max - _min);
    nwrt=(nwrt >= 1.0)?0.99999:nwrt;
    nwrt=(nwrt <= 0.0)?0.00001:nwrt;
    lauf=(int (nwrt/0.2));
    nwrt-=(0.2*lauf);
    nwrt/=(0.2);
    ff=vec4((1.0-nwrt)*farbe[lauf][0]+farbe[lauf+1][0]*nwrt, (1.0-nwrt)*farbe[lauf][1]+farbe[lauf+1][1]*nwrt,
            (1.0-nwrt)*farbe[lauf][2]+farbe[lauf+1][2]*nwrt, 1.0);
    return ff;
}


void main( void ){
    /*int st = 100;
    float drawit = fract(distance_from_start * st);
    if (drawit>0.5) discard;*/
    vec4 col = vec4(1,0,0,1);//red
    if (abs(val) < ((contMax-contMin)/100)) col = vec4(0,0,0,1);//black
    else if (val<0.0) col = vec4(1,0,0,1);
    else if (val>0.0) col = vec4(0,0,1,1);//blue
    if (rainbow) col = farbverlauf(val);
    fragColor = col;
}
